import { feature } from 'topojson';
import { tsv, json } from 'd3';
export const loadAndProcessData = () =>  // not using {} after => means the result of the whole code block gets returned. Therefore, you should explicitly use return statement if you're not using {}
  Promise
    .all([	// Utility that executes multiple promises in parallel	// Pass in an array of promises
      tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
      json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')
    ])
    .then(([tsvData, topoJSONdata]) => {
      const rowById = tsvData.reduce((accumulator, d) => {	// another way of defining a new object by appending elements one by one (with reduce)
        accumulator[d.iso_n3] = d;
        return accumulator;
      }, {});

      const countries = feature(topoJSONdata, topoJSONdata.objects.countries);

      countries.features.forEach(d => {
        Object.assign(d.properties, rowById[d.id]);		// assign each whole row of data to d.properties (assign right arg to left arg)
      });

      return countries;
    });